diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index c73d493a3d8..d135ea84645 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -39,6 +39,9 @@ along with GCC; see the file COPYING3.  If not see
 #include "selftest.h"
 #include "analyzer/analyzer.h"
 #include "analyzer/analyzer-logging.h"
+#include "analyzer/call-string.h"
+#include "analyzer/program-point.h"
+#include "analyzer/store.h"
 #include "analyzer/region-model.h"
 #include "analyzer/constraint-manager.h"
 #include "analyzer/sm.h"
@@ -52,8 +55,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "cgraph.h"
 #include "digraph.h"
 #include "analyzer/supergraph.h"
-#include "analyzer/call-string.h"
-#include "analyzer/program-point.h"
 #include "analyzer/program-state.h"
 #include "analyzer/exploded-graph.h"
 #include "analyzer/analysis-plan.h"
@@ -67,8 +68,6 @@ along with GCC; see the file COPYING3.  If not see
 
 namespace ana {
 
-static int readability_comparator (const void *p1, const void *p2);
-
 /* class impl_region_model_context : public region_model_context.  */
 
 impl_region_model_context::
@@ -76,14 +75,12 @@ impl_region_model_context (exploded_graph &eg,
 			   const exploded_node *enode_for_diag,
 			   const program_state *old_state,
 			   program_state *new_state,
-			   state_change *change,
 			   const gimple *stmt,
 			   stmt_finder *stmt_finder)
 : m_eg (&eg), m_logger (eg.get_logger ()),
   m_enode_for_diag (enode_for_diag),
   m_old_state (old_state),
   m_new_state (new_state),
-  m_change (change),
   m_stmt (stmt),
   m_stmt_finder (stmt_finder),
   m_ext_state (eg.get_ext_state ())
@@ -92,13 +89,11 @@ impl_region_model_context (exploded_graph &eg,
 
 impl_region_model_context::
 impl_region_model_context (program_state *state,
-			   state_change *change,
 			   const extrinsic_state &ext_state,
 			   logger *logger)
 : m_eg (NULL), m_logger (logger), m_enode_for_diag (NULL),
   m_old_state (NULL),
   m_new_state (state),
-  m_change (change),
   m_stmt (NULL),
   m_stmt_finder (NULL),
   m_ext_state (ext_state)
@@ -116,58 +111,55 @@ impl_region_model_context::warn (pending_diagnostic *d)
 }
 
 void
-impl_region_model_context::remap_svalue_ids (const svalue_id_map &map)
+impl_region_model_context::on_svalue_leak (const svalue *sval)
+
 {
-  m_new_state->remap_svalue_ids (map);
-  if (m_change)
-    m_change->remap_svalue_ids (map);
+  int sm_idx;
+  sm_state_map *smap;
+  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
+    smap->on_svalue_leak (sval, this);
 }
 
-int
-impl_region_model_context::on_svalue_purge (svalue_id first_unused_sid,
-					    const svalue_id_map &map)
+void
+impl_region_model_context::
+on_liveness_change (const svalue_set &live_svalues,
+		    const region_model *model)
 {
-  int total = 0;
   int sm_idx;
   sm_state_map *smap;
   FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      total += smap->on_svalue_purge (sm, sm_idx, first_unused_sid,
-				      map, this);
-    }
-  if (m_change)
-    total += m_change->on_svalue_purge (first_unused_sid);
-  return total;
+    smap->on_liveness_change (live_svalues, model, this);
 }
 
 void
-impl_region_model_context::on_unknown_change (svalue_id sid)
+impl_region_model_context::on_unknown_change (const svalue *sval,
+					      bool is_mutable)
 {
   int sm_idx;
   sm_state_map *smap;
   FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    smap->on_unknown_change (sid);
+    smap->on_unknown_change (sval, is_mutable, m_ext_state);
 }
 
 /* class setjmp_svalue : public svalue.  */
 
-/* Compare the fields of this setjmp_svalue with OTHER, returning true
-   if they are equal.
-   For use by svalue::operator==.  */
+/* Implementation of svalue::accept vfunc for setjmp_svalue.  */
 
-bool
-setjmp_svalue::compare_fields (const setjmp_svalue &other) const
+void
+setjmp_svalue::accept (visitor *v) const
 {
-  return m_setjmp_record == other.m_setjmp_record;
+  v->visit_setjmp_svalue (this);
 }
 
-/* Implementation of svalue::add_to_hash vfunc for setjmp_svalue.  */
+/* Implementation of svalue::dump_to_pp vfunc for setjmp_svalue.  */
 
 void
-setjmp_svalue::add_to_hash (inchash::hash &hstate) const
+setjmp_svalue::dump_to_pp (pretty_printer *pp, bool simple) const
 {
-  hstate.add_int (m_setjmp_record.m_enode->m_index);
+  if (simple)
+    pp_printf (pp, "SETJMP(EN: %i)", get_enode_index ());
+  else
+    pp_printf (pp, "setjmp_svalue(EN%i)", get_enode_index ());
 }
 
 /* Get the index of the stored exploded_node.  */
@@ -178,16 +170,6 @@ setjmp_svalue::get_enode_index () const
   return m_setjmp_record.m_enode->m_index;
 }
 
-/* Implementation of svalue::print_details vfunc for setjmp_svalue.  */
-
-void
-setjmp_svalue::print_details (const region_model &model ATTRIBUTE_UNUSED,
-			      svalue_id this_sid ATTRIBUTE_UNUSED,
-			      pretty_printer *pp) const
-{
-  pp_printf (pp, "setjmp: EN: %i", get_enode_index ());
-}
-
 /* Concrete implementation of sm_context, wiring it up to the rest of this
    file.  */
 
@@ -200,7 +182,6 @@ public:
 		   const exploded_node *enode_for_diag,
 		   const program_state *old_state,
 		   program_state *new_state,
-		   state_change *change,
 		   const sm_state_map *old_smap,
 		   sm_state_map *new_smap,
 		   stmt_finder *stmt_finder = NULL)
@@ -208,7 +189,6 @@ public:
     m_logger (eg.get_logger ()),
     m_eg (eg), m_enode_for_diag (enode_for_diag),
     m_old_state (old_state), m_new_state (new_state),
-    m_change (change),
     m_old_smap (old_smap), m_new_smap (new_smap),
     m_stmt_finder (stmt_finder)
   {
@@ -220,13 +200,13 @@ public:
   {
     impl_region_model_context old_ctxt
       (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, call);
+       call);
     region_model *model = m_new_state->m_region_model;
     return model->get_fndecl_for_call (call, &old_ctxt);
   }
 
   void on_transition (const supernode *node  ATTRIBUTE_UNUSED,
-		      const gimple *stmt  ATTRIBUTE_UNUSED,
+		      const gimple *stmt,
 		      tree var,
 		      state_machine::state_t from,
 		      state_machine::state_t to,
@@ -236,19 +216,20 @@ public:
     LOG_FUNC (logger);
     impl_region_model_context old_ctxt
       (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, stmt);
-    svalue_id var_old_sid
+       stmt);
+    const svalue *var_old_sval
       = m_old_state->m_region_model->get_rvalue (var, &old_ctxt);
 
     impl_region_model_context new_ctxt (m_eg, m_enode_for_diag,
 					m_old_state, m_new_state,
-					m_change, NULL);
-    svalue_id var_new_sid
+					stmt);
+    const svalue *var_new_sval
       = m_new_state->m_region_model->get_rvalue (var, &new_ctxt);
-    svalue_id origin_new_sid
+    const svalue *origin_new_sval
       = m_new_state->m_region_model->get_rvalue (origin, &new_ctxt);
 
-    state_machine::state_t current = m_old_smap->get_state (var_old_sid);
+    state_machine::state_t current
+      = m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ());
     if (current == from)
       {
 	if (logger)
@@ -257,10 +238,8 @@ public:
 		       var,
 		       m_sm.get_state_name (from),
 		       m_sm.get_state_name (to));
-	m_new_smap->set_state (m_new_state->m_region_model, var_new_sid,
-			       to, origin_new_sid);
-	if (m_change)
-	  m_change->add_sm_change (m_sm_idx, var_new_sid, from, to);
+	m_new_smap->set_state (m_new_state->m_region_model, var_new_sval,
+			       to, origin_new_sval, m_eg.get_ext_state ());
       }
   }
 
@@ -272,22 +251,24 @@ public:
     gcc_assert (d); // take ownership
 
     impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, m_old_state, m_new_state, m_change, NULL);
+      (m_eg, m_enode_for_diag, m_old_state, m_new_state, NULL);
     state_machine::state_t current;
     if (var)
       {
-	svalue_id var_old_sid
+	const svalue *var_old_sval
 	  = m_old_state->m_region_model->get_rvalue (var, &old_ctxt);
-	current = m_old_smap->get_state (var_old_sid);
+	current = m_old_smap->get_state (var_old_sval, m_eg.get_ext_state ());
       }
     else
       current = m_old_smap->get_global_state ();
 
     if (state == current)
       {
+	const svalue *var_old_sval
+	  = m_old_state->m_region_model->get_rvalue (var, &old_ctxt);
 	m_eg.get_diagnostic_manager ().add_diagnostic
 	  (&m_sm, m_enode_for_diag, snode, stmt, m_stmt_finder,
-	   var, state, d);
+	   var, var_old_sval, state, d);
       }
     else
       delete d;
@@ -299,7 +280,7 @@ public:
      we can print:
        "double-free of 'inbuf.data'".  */
 
-  tree get_readable_tree (tree expr) FINAL OVERRIDE
+  tree get_diagnostic_tree (tree expr) FINAL OVERRIDE
   {
     /* Only for SSA_NAMEs of temporaries; otherwise, return EXPR, as it's
        likely to be the least surprising tree to report.  */
@@ -309,16 +290,12 @@ public:
       return expr;
 
     gcc_assert (m_new_state);
-    svalue_id sid = m_new_state->m_region_model->get_rvalue (expr, NULL);
+    const svalue *sval = m_new_state->m_region_model->get_rvalue (expr, NULL);
     /* Find trees for all regions storing the value.  */
-    auto_vec<path_var> pvs;
-    m_new_state->m_region_model->get_path_vars_for_svalue (sid, &pvs);
-    if (pvs.length () < 1)
+    if (tree t = m_new_state->m_region_model->get_representative_tree (sval))
+      return t;
+    else
       return expr;
-    /* Pick the "best" such tree.  */
-    // TODO: should we also consider (and consolidate) equiv classes?
-    pvs.qsort (readability_comparator);
-    return pvs[0].m_tree;
   }
 
   state_machine::state_t get_global_state () const FINAL OVERRIDE
@@ -338,12 +315,27 @@ public:
 				 m_sm_idx);
   }
 
+  tree is_zero_assignment (const gimple *stmt) FINAL OVERRIDE
+  {
+    const gassign *assign_stmt = dyn_cast <const gassign *> (stmt);
+    if (!assign_stmt)
+     return NULL_TREE;
+    impl_region_model_context old_ctxt
+      (m_eg, m_enode_for_diag, m_old_state, m_new_state, stmt);
+    if (const svalue *sval
+	= m_new_state->m_region_model->get_gassign_result (assign_stmt,
+							    &old_ctxt))
+      if (tree cst = sval->maybe_get_constant ())
+	if (::zerop(cst))
+	  return gimple_assign_lhs (assign_stmt);
+    return NULL_TREE;
+  }
+
   log_user m_logger;
   exploded_graph &m_eg;
   const exploded_node *m_enode_for_diag;
   const program_state *m_old_state;
   program_state *m_new_state;
-  state_change *m_change;
   const sm_state_map *m_old_smap;
   sm_state_map *m_new_smap;
   stmt_finder *m_stmt_finder;
@@ -369,7 +361,7 @@ public:
     logger * const logger = m_eg.get_logger ();
     LOG_FUNC (logger);
 
-    if (TREE_CODE (m_var) == SSA_NAME)
+    if (m_var && TREE_CODE (m_var) == SSA_NAME)
       {
 	/* Locate the final write to this SSA name in the path.  */
 	const gimple *def_stmt = SSA_NAME_DEF_STMT (m_var);
@@ -452,20 +444,34 @@ readability (const_tree expr)
     case MEM_REF:
       /* Impose a slight readability penalty relative to that of
 	 operand 0.  */
-      return readability (TREE_OPERAND (expr, 0)) - 1;
+      return readability (TREE_OPERAND (expr, 0)) - 16;
 
     case SSA_NAME:
       {
 	if (tree var = SSA_NAME_VAR (expr))
-	  return readability (var);
+	  /* Slightly favor the underlying var over the SSA name to
+	     avoid having them compare equal.  */
+	  return readability (var) - 1;
 	/* Avoid printing '<unknown>' for SSA names for temporaries.  */
 	return -1;
       }
       break;
 
+    case PARM_DECL:
     case VAR_DECL:
-      /* Arbitrarily-chosen "high readability" value.  */
-      return 256;
+      if (DECL_NAME (expr))
+	/* Arbitrarily-chosen "high readability" value.  */
+	return 65536;
+      else
+	/* We don't want to print temporaries.  For example, the C FE
+	   prints them as e.g. "<Uxxxx>" where "xxxx" is the low 16 bits
+	   of the tree pointer (see pp_c_tree_decl_identifier).  */
+	return -1;
+
+    case RESULT_DECL:
+      /* Printing "<return-value>" isn't ideal, but is less awful than
+	 trying to print a temporary.  */
+      return 32768;
 
     default:
       return 0;
@@ -477,109 +483,73 @@ readability (const_tree expr)
 /* A qsort comparator for trees to sort them into most user-readable to
    least user-readable.  */
 
-static int
+int
 readability_comparator (const void *p1, const void *p2)
 {
   path_var pv1 = *(path_var const *)p1;
   path_var pv2 = *(path_var const *)p2;
 
-  /* TODO: should we consider stack depths?  */
   int r1 = readability (pv1.m_tree);
   int r2 = readability (pv2.m_tree);
+  if (int cmp = r2 - r1)
+    return cmp;
 
-  return r2 - r1;
+  /* Favor items that are deeper on the stack and hence more recent;
+     this also favors locals over globals.  */
+  if (int cmp = pv2.m_stack_depth - pv1.m_stack_depth)
+    return cmp;
+
+  /* TODO: We ought to find ways of sorting such cases.  */
+  return 0;
 }
 
-/* Create an sm_context and use it to call SM's on_leak vfunc, so that
-   it can potentially complain about a leak of DST_SID (in a new region_model)
-   in the given STATE, where MAP can be used to map SID back to an "old"
-   region_model.  */
+/* Find the best tree for SVAL and call SM's on_leak vfunc with it.
+   If on_leak returns a pending_diagnostic, queue it up to be reported,
+   so that we potentially complain about a leak of SVAL in the given STATE.  */
 
 void
 impl_region_model_context::on_state_leak (const state_machine &sm,
-					  int sm_idx,
-					  svalue_id dst_sid,
-					  svalue_id first_unused_sid,
-					  const svalue_id_map &map,
+					  const svalue *sval,
 					  state_machine::state_t state)
 {
   logger * const logger = get_logger ();
   LOG_SCOPE (logger);
   if (logger)
-    logger->log ("considering leak of sv%i", dst_sid.as_int ());
+    {
+      logger->start_log_line ();
+      logger->log_partial ("considering leak of ");
+      sval->dump_to_pp (logger->get_printer (), true);
+      logger->end_log_line ();
+    }
 
   if (!m_eg)
     return;
 
   /* m_old_state also needs to be non-NULL so that the sm_ctxt can look
-     up the old state of the sid.  */
+     up the old state of SVAL.  */
   gcc_assert (m_old_state);
 
-  /* Don't report on sid leaking if it's equal to one of the used sids.
-     For example, given:
-       some_non_trivial_expression = malloc (sizeof (struct foo));
-     we have:
-       _1 = malloc;                         (void *)
-       some_non_trivial_expression = _1;    (struct foo *)
-     and at leak-detection time we may have:
-       sv5: {type: 'struct foo *', &r3}  (used)
-       sv6: {type: 'void *', &r3}         (unused)
-     where both point to the same region.  We don't want to report a
-     leak of sv6, so we reject the report due to its equality with sv5.  */
-  gcc_assert (m_new_state);
-  gcc_assert (!first_unused_sid.null_p ());
-  for (int i = 0; i < first_unused_sid.as_int (); i++)
+  /* SVAL has leaked within the new state: it is not used by any reachable
+     regions.
+     We need to convert it back to a tree, but since it's likely no regions
+     use it, we have to find the "best" tree for it in the old_state.  */
+  svalue_set visited;
+  path_var leaked_pv
+    = m_old_state->m_region_model->get_representative_path_var (sval,
+								&visited);
+
+  /* This might be NULL; the pending_diagnostic subclasses need to cope
+     with this.  */
+  tree leaked_tree = leaked_pv.m_tree;
+  if (logger)
     {
-      svalue_id used_sid = svalue_id::from_int (i);
-
-      /* Use the "_without_cm" form of eval_condition, since
-	 we're half-way through purging - we don't want to introduce new
-	 equivalence classes into the constraint_manager for "sid" and
-	 for each of the used_sids.  */
-      const region_model &rm = *m_new_state->m_region_model;
-      tristate eq = rm.eval_condition_without_cm (dst_sid, EQ_EXPR, used_sid);
-      if (eq.is_true ())
-	{
-	  if (logger)
-	    logger->log ("rejecting leak of sv%i due to equality with sv%i",
-			 dst_sid.as_int (), used_sid.as_int ());
-	  return;
-	}
+      if (leaked_tree)
+	logger->log ("best leaked_tree: %qE", leaked_tree);
+      else
+	logger->log ("best leaked_tree: NULL");
     }
 
-  /* SID has leaked within the new state: no regions use it.
-     We need to convert it back to a tree, but since no regions use it, we
-     have to use MAP to convert it back to an svalue_id within the old state.
-     We can then look that svalue_id up to locate regions and thus tree(s)
-     that use it.  */
-
-  svalue_id old_sid = map.get_src_for_dst (dst_sid);
-
-  auto_vec<path_var> leaked_pvs;
-  m_old_state->m_region_model->get_path_vars_for_svalue (old_sid, &leaked_pvs);
-
-  if (leaked_pvs.length () < 1)
-    return;
-
-  /* Find "best" leaked tree.
-     Sort the leaks into most human-readable first, through
-     to least user-readable.  Given that we only emit one
-     leak per EC, this ought to ensure that we pick the most
-     user-readable description of each leaking EC.
-     This assumes that all vars in the EC have the same state.  */
-  leaked_pvs.qsort (readability_comparator);
-
-  tree leaked_tree = leaked_pvs[0].m_tree;
-  if (logger)
-    logger->log ("best leaked_tree: %qE", leaked_tree);
-
   leak_stmt_finder stmt_finder (*m_eg, leaked_tree);
-  impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
-			   m_old_state, m_new_state,
-			   m_change,
-			   m_old_state->m_checker_states[sm_idx],
-			   m_new_state->m_checker_states[sm_idx],
-			   &stmt_finder);
   gcc_assert (m_enode_for_diag);
 
   /* Don't complain about leaks when returning from "main".  */
@@ -587,7 +557,7 @@ impl_region_model_context::on_state_leak (const state_machine &sm,
       && m_enode_for_diag->get_supernode ()->return_p ())
     {
       tree fndecl = m_enode_for_diag->get_function ()->decl;
-      if (0 == strcmp (IDENTIFIER_POINTER (DECL_NAME (fndecl)), "main"))
+      if (id_equal (DECL_NAME (fndecl), "main"))
 	{
 	  if (logger)
 	    logger->log ("not reporting leak from main");
@@ -600,48 +570,7 @@ impl_region_model_context::on_state_leak (const state_machine &sm,
     m_eg->get_diagnostic_manager ().add_diagnostic
       (&sm, m_enode_for_diag, m_enode_for_diag->get_supernode (),
        m_stmt, &stmt_finder,
-       leaked_tree, state, pd);
-}
-
-/* Implementation of region_model_context::on_inherited_svalue vfunc
-   for impl_region_model_context.
-   Notify all checkers that CHILD_SID has been created from PARENT_SID,
-   so that those state machines that inherit state can propagate the state
-   from parent to child.  */
-
-void
-impl_region_model_context::on_inherited_svalue (svalue_id parent_sid,
-						svalue_id child_sid)
-{
-  if (!m_new_state)
-    return;
-
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      if (sm.inherited_state_p ())
-	smap->on_inherited_svalue (parent_sid, child_sid);
-    }
-}
-
-/* Implementation of region_model_context::on_cast vfunc
-   for impl_region_model_context.
-   Notify all checkers that DST_SID is a cast of SRC_SID, so that sm-state
-   can be propagated from src to dst.  */
-
-void
-impl_region_model_context::on_cast (svalue_id src_sid,
-				    svalue_id dst_sid)
-{
-  if (!m_new_state)
-    return;
-
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    smap->on_cast (src_sid, dst_sid);
+       leaked_tree, sval, state, pd);
 }
 
 /* Implementation of region_model_context::on_condition vfunc.
@@ -658,7 +587,6 @@ impl_region_model_context::on_condition (tree lhs, enum tree_code op, tree rhs)
       const state_machine &sm = m_ext_state.get_sm (sm_idx);
       impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
 			       m_old_state, m_new_state,
-			       m_change,
 			       m_old_state->m_checker_states[sm_idx],
 			       m_new_state->m_checker_states[sm_idx]);
       sm.on_condition (&sm_ctxt,
@@ -681,7 +609,6 @@ impl_region_model_context::on_phi (const gphi *phi, tree rhs)
       const state_machine &sm = m_ext_state.get_sm (sm_idx);
       impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
 			       m_old_state, m_new_state,
-			       m_change,
 			       m_old_state->m_checker_states[sm_idx],
 			       m_new_state->m_checker_states[sm_idx]);
       sm.on_phi (&sm_ctxt, m_enode_for_diag->get_supernode (), phi, rhs);
@@ -699,7 +626,7 @@ impl_region_model_context::on_unexpected_tree_code (tree t,
   logger * const logger = get_logger ();
   if (logger)
     logger->log ("unhandled tree code: %qs in %qs at %s:%i",
-		 t ? get_tree_code_name (TREE_CODE (t)) : "(null)",
+		 get_tree_code_name (TREE_CODE (t)),
 		 loc.get_impl_location ().m_function,
 		 loc.get_impl_location ().m_file,
 		 loc.get_impl_location ().m_line);
@@ -730,10 +657,13 @@ point_and_state::validate (const extrinsic_state &ext_state) const
 	      == m_state.m_region_model->get_stack_depth ());
   /* Check the functions in the callstring vs those in the frames
      at each depth.  */
-  for (int depth = 0; depth < m_point.get_stack_depth (); ++depth)
+  for (const frame_region *iter_frame
+	 = m_state.m_region_model->get_current_frame ();
+       iter_frame; iter_frame = iter_frame->get_calling_frame ())
     {
-      gcc_assert (m_point.get_function_at_depth (depth)
-		  == m_state.m_region_model->get_function_at_depth (depth));
+      int index = iter_frame->get_index ();
+      gcc_assert (m_point.get_function_at_depth (index)
+		  == iter_frame->get_function ());
     }
 }
 
@@ -797,17 +727,71 @@ print_enode_indices (pretty_printer *pp,
     }
 }
 
+/* struct eg_traits::dump_args_t.  */
+
+/* The <FILENAME>.eg.dot output can quickly become unwieldy if we show
+   full details for all enodes (both in terms of CPU time to render it,
+   and in terms of being meaningful to a human viewing it).
+
+   If we show just the IDs then the resulting graph is usually viewable,
+   but then we have to keep switching back and forth between the .dot
+   view and other dumps.
+
+   This function implements a heuristic for showing detail at the enodes
+   that (we hope) matter, and just the ID at other enodes, fixing the CPU
+   usage of the .dot viewer, and drawing the attention of the viewer
+   to these enodes.
+
+   Return true if ENODE should be shown in detail in .dot output.
+   Return false if no detail should be shown for ENODE.  */
+
+bool
+eg_traits::dump_args_t::show_enode_details_p (const exploded_node &enode) const
+{
+  /* If the number of exploded nodes isn't too large, we may as well show
+     all enodes in full detail in the .dot output.  */
+  if (m_eg.m_nodes.length ()
+	<= (unsigned) param_analyzer_max_enodes_for_full_dump)
+    return true;
+
+  /* Otherwise, assume that what's most interesting are state explosions,
+     and thus the places where this happened.
+     Expand enodes at program points where we hit the per-enode limit, so we
+     can investigate what exploded.  */
+  const per_program_point_data *per_point_data
+    = m_eg.get_per_program_point_data (enode.get_point ());
+  return per_point_data->m_excess_enodes > 0;
+}
+
 /* class exploded_node : public dnode<eg_traits>.  */
 
 /* exploded_node's ctor.  */
 
 exploded_node::exploded_node (const point_and_state &ps,
 			      int index)
-: m_ps (ps), m_status (STATUS_WORKLIST), m_index (index)
+: m_ps (ps), m_status (STATUS_WORKLIST), m_index (index),
+  m_num_processed_stmts (0)
 {
   gcc_checking_assert (ps.get_state ().m_region_model->canonicalized_p ());
 }
 
+/* Get the stmt that was processed in this enode at index IDX.
+   IDX is an index within the stmts processed at this enode, rather
+   than within those of the supernode.  */
+
+const gimple *
+exploded_node::get_processed_stmt (unsigned idx) const
+{
+  gcc_assert (idx < m_num_processed_stmts);
+  const program_point &point = get_point ();
+  gcc_assert (point.get_kind () == PK_BEFORE_STMT);
+  const supernode *snode = get_supernode ();
+  const unsigned int point_stmt_idx = point.get_stmt_idx ();
+  const unsigned int idx_within_snode = point_stmt_idx + idx;
+  const gimple *stmt = snode->m_stmts[idx_within_snode];
+  return stmt;
+}
+
 /* For use by dump_dot, get a value for the .dot "fillcolor" attribute.
    Colorize by sm-state, to make it easier to see how sm-state propagates
    through the exploded_graph.  */
@@ -829,7 +813,7 @@ exploded_node::get_dot_fillcolor () const
   FOR_EACH_VEC_ELT (state.m_checker_states, i, smap)
     {
       for (sm_state_map::iterator_t iter = smap->begin ();
-	 iter != smap->end ();
+	   iter != smap->end ();
 	   ++iter)
 	total_sm_state += (*iter).second.m_state;
       total_sm_state += smap->get_global_state ();
@@ -839,7 +823,9 @@ exploded_node::get_dot_fillcolor () const
     {
       /* An arbitrarily-picked collection of light colors.  */
       const char * const colors[]
-	= {"azure", "coral", "cornsilk", "lightblue", "yellow"};
+	= {"azure", "coral", "cornsilk", "lightblue", "yellow",
+	   "honeydew", "lightpink", "lightsalmon", "palegreen1",
+	   "wheat", "seashell"};
       const int num_colors = sizeof (colors) / sizeof (colors[0]);
       return colors[total_sm_state % num_colors];
     }
@@ -865,28 +851,38 @@ exploded_node::dump_dot (graphviz_out *gv, const dump_args_t &args) const
     pp_string (pp, " (merger)");
   pp_newline (pp);
 
-  format f (true);
-  m_ps.get_point ().print (pp, f);
-  pp_newline (pp);
+  if (args.show_enode_details_p (*this))
+    {
+      format f (true);
+      m_ps.get_point ().print (pp, f);
+      pp_newline (pp);
 
-  const extrinsic_state &ext_state = args.m_eg.get_ext_state ();
-  const program_state &state = m_ps.get_state ();
-  state.dump_to_pp (ext_state, true, pp);
-  pp_newline (pp);
+      const extrinsic_state &ext_state = args.m_eg.get_ext_state ();
+      const program_state &state = m_ps.get_state ();
+      state.dump_to_pp (ext_state, false, true, pp);
+      pp_newline (pp);
 
-  {
-    int i;
-    sm_state_map *smap;
-    FOR_EACH_VEC_ELT (state.m_checker_states, i, smap)
-      {
-	if (!smap->is_empty_p ())
-	  {
-	    pp_printf (pp, "%s: ", ext_state.get_name (i));
-	    smap->print (ext_state.get_sm (i), state.m_region_model, pp);
-	    pp_newline (pp);
-	  }
-      }
-  }
+      /* Show any stmts that were processed within this enode,
+	 and their index within the supernode.  */
+      if (m_num_processed_stmts > 0)
+	{
+	  const program_point &point = get_point ();
+	  gcc_assert (point.get_kind () == PK_BEFORE_STMT);
+	  const supernode *snode = get_supernode ();
+	  const unsigned int point_stmt_idx = point.get_stmt_idx ();
+
+	  pp_printf (pp, "stmts: %i", m_num_processed_stmts);
+	  pp_newline (pp);
+	  for (unsigned i = 0; i < m_num_processed_stmts; i++)
+	    {
+	      const unsigned int idx_within_snode = point_stmt_idx + i;
+	      const gimple *stmt = snode->m_stmts[idx_within_snode];
+	      pp_printf (pp, "  %i: ", idx_within_snode);
+	      pp_gimple_stmt_1 (pp, stmt, 0, (dump_flags_t)0);
+	      pp_newline (pp);
+	    }
+	}
+    }
 
   /* Dump any saved_diagnostics at this enode.  */
   {
@@ -929,7 +925,7 @@ exploded_node::dump_to_pp (pretty_printer *pp,
   m_ps.get_point ().print (pp, f);
   pp_newline (pp);
 
-  m_ps.get_state ().dump_to_pp (ext_state, false, pp);
+  m_ps.get_state ().dump_to_pp (ext_state, false, true, pp);
   pp_newline (pp);
 }
 
@@ -1002,9 +998,23 @@ exploded_node::on_stmt_flags
 exploded_node::on_stmt (exploded_graph &eg,
 			const supernode *snode,
 			const gimple *stmt,
-			program_state *state,
-			state_change *change) const
+			program_state *state) const
 {
+  logger *logger = eg.get_logger ();
+  LOG_SCOPE (logger);
+  if (logger)
+    {
+      logger->start_log_line ();
+      pp_gimple_stmt_1 (logger->get_printer (), stmt, 0, (dump_flags_t)0);
+      logger->end_log_line ();
+    }
+
+  /* Update input_location in case of ICE: make it easier to track down which
+     source construct we're failing to handle.  */
+  input_location = stmt->location;
+
+  gcc_assert (state->m_region_model);
+
   /* Preserve the old state.  It is used here for looking
      up old checker states, for determining state transitions, and
      also within impl_region_model_context and impl_sm_context for
@@ -1012,7 +1022,7 @@ exploded_node::on_stmt (exploded_graph &eg,
   const program_state old_state (*state);
 
   impl_region_model_context ctxt (eg, this,
-				  &old_state, state, change,
+				  &old_state, state,
 				  stmt);
 
   if (const gassign *assign = dyn_cast <const gassign *> (stmt))
@@ -1028,11 +1038,13 @@ exploded_node::on_stmt (exploded_graph &eg,
   if (const gcall *call = dyn_cast <const gcall *> (stmt))
     {
       /* Debugging/test support.  */
-      if (is_special_named_call_p (call, "__analyzer_dump", 0))
+      if (is_special_named_call_p (call, "__analyzer_describe", 2))
+	state->m_region_model->impl_call_analyzer_describe (call, &ctxt);
+      else if (is_special_named_call_p (call, "__analyzer_dump", 0))
 	{
 	  /* Handle the builtin "__analyzer_dump" by dumping state
 	     to stderr.  */
-	  dump (eg.get_ext_state ());
+	  state->dump (eg.get_ext_state (), true);
 	}
       else if (is_special_named_call_p (call, "__analyzer_dump_path", 0))
 	{
@@ -1047,19 +1059,7 @@ exploded_node::on_stmt (exploded_graph &eg,
 	  state->m_region_model->dump (false);
 	}
       else if (is_special_named_call_p (call, "__analyzer_eval", 1))
-	{
-	  /* Handle the builtin "__analyzer_eval" by evaluating the input
-	     and dumping as a dummy warning, so that test cases can use
-	     dg-warning to validate the result (and so unexpected warnings will
-	     lead to DejaGnu failures).  */
-	  tree t_arg = gimple_call_arg (call, 0);
-	  tristate t
-	    = state->m_region_model->eval_condition (t_arg,
-						     NE_EXPR,
-						     integer_zero_node,
-						     &ctxt);
-	  warning_at (call->location, 0, "%s", t.as_string ());
-	}
+	state->m_region_model->impl_call_analyzer_eval (call, &ctxt);
       else if (is_special_named_call_p (call, "__analyzer_break", 0))
 	{
 	  /* Handle the builtin "__analyzer_break" by triggering a
@@ -1093,25 +1093,10 @@ exploded_node::on_stmt (exploded_graph &eg,
 	= old_state.m_checker_states[sm_idx];
       sm_state_map *new_smap = state->m_checker_states[sm_idx];
       impl_sm_context sm_ctxt (eg, sm_idx, sm, this, &old_state, state,
-			       change,
 			       old_smap, new_smap);
       /* Allow the state_machine to handle the stmt.  */
       if (sm.on_stmt (&sm_ctxt, snode, stmt))
 	unknown_side_effects = false;
-      else
-	{
-	  /* For those stmts that were not handled by the state machine.  */
-	  if (const gcall *call = dyn_cast <const gcall *> (stmt))
-	    {
-	      tree callee_fndecl
-		= state->m_region_model->get_fndecl_for_call (call, &ctxt);
-
-	      if (!fndecl_has_gimple_body_p (callee_fndecl))
-		new_smap->purge_for_unknown_fncall (eg, sm, call, callee_fndecl,
-						    state->m_region_model,
-						    &ctxt);
-	    }
-	}
       if (*old_smap != *new_smap)
 	any_sm_changes = true;
     }
@@ -1142,15 +1127,14 @@ bool
 exploded_node::on_edge (exploded_graph &eg,
 			const superedge *succ,
 			program_point *next_point,
-			program_state *next_state,
-			state_change *change) const
+			program_state *next_state) const
 {
   LOG_FUNC (eg.get_logger ());
 
   if (!next_point->on_edge (eg, succ))
     return false;
 
-  if (!next_state->on_edge (eg, *this, succ, change))
+  if (!next_state->on_edge (eg, *this, succ))
     return false;
 
   return true;
